# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rail_mesh_icp/ICPMatchRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg
import std_msgs.msg

class ICPMatchRequest(genpy.Message):
  _md5sum = "ed24817354c0056931a56cfc36c53e02"
  _type = "rail_mesh_icp/ICPMatchRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """sensor_msgs/PointCloud2 template_cloud
sensor_msgs/PointCloud2 target_cloud

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field
"""
  __slots__ = ['template_cloud','target_cloud']
  _slot_types = ['sensor_msgs/PointCloud2','sensor_msgs/PointCloud2']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       template_cloud,target_cloud

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ICPMatchRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.template_cloud is None:
        self.template_cloud = sensor_msgs.msg.PointCloud2()
      if self.target_cloud is None:
        self.target_cloud = sensor_msgs.msg.PointCloud2()
    else:
      self.template_cloud = sensor_msgs.msg.PointCloud2()
      self.target_cloud = sensor_msgs.msg.PointCloud2()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.template_cloud.header.seq, _x.template_cloud.header.stamp.secs, _x.template_cloud.header.stamp.nsecs))
      _x = self.template_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.template_cloud.height, _x.template_cloud.width))
      length = len(self.template_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.template_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.template_cloud.is_bigendian, _x.template_cloud.point_step, _x.template_cloud.row_step))
      _x = self.template_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B3I().pack(_x.template_cloud.is_dense, _x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs))
      _x = self.target_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.target_cloud.height, _x.target_cloud.width))
      length = len(self.target_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.target_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step))
      _x = self.target_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.target_cloud.is_dense
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.template_cloud is None:
        self.template_cloud = sensor_msgs.msg.PointCloud2()
      if self.target_cloud is None:
        self.target_cloud = sensor_msgs.msg.PointCloud2()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.template_cloud.header.seq, _x.template_cloud.header.stamp.secs, _x.template_cloud.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.template_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.template_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.template_cloud.height, _x.template_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.template_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.template_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.template_cloud.is_bigendian, _x.template_cloud.point_step, _x.template_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.template_cloud.is_bigendian = bool(self.template_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.template_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.template_cloud.is_dense, _x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs,) = _get_struct_B3I().unpack(str[start:end])
      self.template_cloud.is_dense = bool(self.template_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.target_cloud.height, _x.target_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.target_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.target_cloud.is_bigendian = bool(self.target_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target_cloud.data = str[start:end]
      start = end
      end += 1
      (self.target_cloud.is_dense,) = _get_struct_B().unpack(str[start:end])
      self.target_cloud.is_dense = bool(self.target_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.template_cloud.header.seq, _x.template_cloud.header.stamp.secs, _x.template_cloud.header.stamp.nsecs))
      _x = self.template_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.template_cloud.height, _x.template_cloud.width))
      length = len(self.template_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.template_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.template_cloud.is_bigendian, _x.template_cloud.point_step, _x.template_cloud.row_step))
      _x = self.template_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B3I().pack(_x.template_cloud.is_dense, _x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs))
      _x = self.target_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.target_cloud.height, _x.target_cloud.width))
      length = len(self.target_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.target_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step))
      _x = self.target_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.target_cloud.is_dense
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.template_cloud is None:
        self.template_cloud = sensor_msgs.msg.PointCloud2()
      if self.target_cloud is None:
        self.target_cloud = sensor_msgs.msg.PointCloud2()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.template_cloud.header.seq, _x.template_cloud.header.stamp.secs, _x.template_cloud.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.template_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.template_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.template_cloud.height, _x.template_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.template_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.template_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.template_cloud.is_bigendian, _x.template_cloud.point_step, _x.template_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.template_cloud.is_bigendian = bool(self.template_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.template_cloud.data = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.template_cloud.is_dense, _x.target_cloud.header.seq, _x.target_cloud.header.stamp.secs, _x.target_cloud.header.stamp.nsecs,) = _get_struct_B3I().unpack(str[start:end])
      self.template_cloud.is_dense = bool(self.template_cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.target_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.target_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.target_cloud.height, _x.target_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.target_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.target_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.target_cloud.is_bigendian, _x.target_cloud.point_step, _x.target_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.target_cloud.is_bigendian = bool(self.target_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.target_cloud.data = str[start:end]
      start = end
      end += 1
      (self.target_cloud.is_dense,) = _get_struct_B().unpack(str[start:end])
      self.target_cloud.is_dense = bool(self.target_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_B2I = None
def _get_struct_B2I():
    global _struct_B2I
    if _struct_B2I is None:
        _struct_B2I = struct.Struct("<B2I")
    return _struct_B2I
_struct_B3I = None
def _get_struct_B3I():
    global _struct_B3I
    if _struct_B3I is None:
        _struct_B3I = struct.Struct("<B3I")
    return _struct_B3I
_struct_IBI = None
def _get_struct_IBI():
    global _struct_IBI
    if _struct_IBI is None:
        _struct_IBI = struct.Struct("<IBI")
    return _struct_IBI
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rail_mesh_icp/ICPMatchResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import sensor_msgs.msg
import std_msgs.msg

class ICPMatchResponse(genpy.Message):
  _md5sum = "0204bc8cfa286a9506ffecd57c8a6ef9"
  _type = "rail_mesh_icp/ICPMatchResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """sensor_msgs/PointCloud2 matched_template_cloud
geometry_msgs/Transform match_tf
float64 match_error


================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['matched_template_cloud','match_tf','match_error']
  _slot_types = ['sensor_msgs/PointCloud2','geometry_msgs/Transform','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       matched_template_cloud,match_tf,match_error

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ICPMatchResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.matched_template_cloud is None:
        self.matched_template_cloud = sensor_msgs.msg.PointCloud2()
      if self.match_tf is None:
        self.match_tf = geometry_msgs.msg.Transform()
      if self.match_error is None:
        self.match_error = 0.
    else:
      self.matched_template_cloud = sensor_msgs.msg.PointCloud2()
      self.match_tf = geometry_msgs.msg.Transform()
      self.match_error = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.matched_template_cloud.header.seq, _x.matched_template_cloud.header.stamp.secs, _x.matched_template_cloud.header.stamp.nsecs))
      _x = self.matched_template_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.matched_template_cloud.height, _x.matched_template_cloud.width))
      length = len(self.matched_template_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.matched_template_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.matched_template_cloud.is_bigendian, _x.matched_template_cloud.point_step, _x.matched_template_cloud.row_step))
      _x = self.matched_template_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B8d().pack(_x.matched_template_cloud.is_dense, _x.match_tf.translation.x, _x.match_tf.translation.y, _x.match_tf.translation.z, _x.match_tf.rotation.x, _x.match_tf.rotation.y, _x.match_tf.rotation.z, _x.match_tf.rotation.w, _x.match_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.matched_template_cloud is None:
        self.matched_template_cloud = sensor_msgs.msg.PointCloud2()
      if self.match_tf is None:
        self.match_tf = geometry_msgs.msg.Transform()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.matched_template_cloud.header.seq, _x.matched_template_cloud.header.stamp.secs, _x.matched_template_cloud.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.matched_template_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.matched_template_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.matched_template_cloud.height, _x.matched_template_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.matched_template_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.matched_template_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.matched_template_cloud.is_bigendian, _x.matched_template_cloud.point_step, _x.matched_template_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.matched_template_cloud.is_bigendian = bool(self.matched_template_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.matched_template_cloud.data = str[start:end]
      _x = self
      start = end
      end += 65
      (_x.matched_template_cloud.is_dense, _x.match_tf.translation.x, _x.match_tf.translation.y, _x.match_tf.translation.z, _x.match_tf.rotation.x, _x.match_tf.rotation.y, _x.match_tf.rotation.z, _x.match_tf.rotation.w, _x.match_error,) = _get_struct_B8d().unpack(str[start:end])
      self.matched_template_cloud.is_dense = bool(self.matched_template_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.matched_template_cloud.header.seq, _x.matched_template_cloud.header.stamp.secs, _x.matched_template_cloud.header.stamp.nsecs))
      _x = self.matched_template_cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.matched_template_cloud.height, _x.matched_template_cloud.width))
      length = len(self.matched_template_cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.matched_template_cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_IBI().pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_get_struct_B2I().pack(_x.matched_template_cloud.is_bigendian, _x.matched_template_cloud.point_step, _x.matched_template_cloud.row_step))
      _x = self.matched_template_cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B8d().pack(_x.matched_template_cloud.is_dense, _x.match_tf.translation.x, _x.match_tf.translation.y, _x.match_tf.translation.z, _x.match_tf.rotation.x, _x.match_tf.rotation.y, _x.match_tf.rotation.z, _x.match_tf.rotation.w, _x.match_error))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.matched_template_cloud is None:
        self.matched_template_cloud = sensor_msgs.msg.PointCloud2()
      if self.match_tf is None:
        self.match_tf = geometry_msgs.msg.Transform()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.matched_template_cloud.header.seq, _x.matched_template_cloud.header.stamp.secs, _x.matched_template_cloud.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.matched_template_cloud.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.matched_template_cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.matched_template_cloud.height, _x.matched_template_cloud.width,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.matched_template_cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _get_struct_IBI().unpack(str[start:end])
        self.matched_template_cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.matched_template_cloud.is_bigendian, _x.matched_template_cloud.point_step, _x.matched_template_cloud.row_step,) = _get_struct_B2I().unpack(str[start:end])
      self.matched_template_cloud.is_bigendian = bool(self.matched_template_cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.matched_template_cloud.data = str[start:end]
      _x = self
      start = end
      end += 65
      (_x.matched_template_cloud.is_dense, _x.match_tf.translation.x, _x.match_tf.translation.y, _x.match_tf.translation.z, _x.match_tf.rotation.x, _x.match_tf.rotation.y, _x.match_tf.rotation.z, _x.match_tf.rotation.w, _x.match_error,) = _get_struct_B8d().unpack(str[start:end])
      self.matched_template_cloud.is_dense = bool(self.matched_template_cloud.is_dense)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_B2I = None
def _get_struct_B2I():
    global _struct_B2I
    if _struct_B2I is None:
        _struct_B2I = struct.Struct("<B2I")
    return _struct_B2I
_struct_B8d = None
def _get_struct_B8d():
    global _struct_B8d
    if _struct_B8d is None:
        _struct_B8d = struct.Struct("<B8d")
    return _struct_B8d
_struct_IBI = None
def _get_struct_IBI():
    global _struct_IBI
    if _struct_IBI is None:
        _struct_IBI = struct.Struct("<IBI")
    return _struct_IBI
class ICPMatch(object):
  _type          = 'rail_mesh_icp/ICPMatch'
  _md5sum = '912591c24166b8839e6467892531883e'
  _request_class  = ICPMatchRequest
  _response_class = ICPMatchResponse
