// Auto-generated. Do not edit!

// (in-package rail_mesh_icp.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let sensor_msgs = _finder('sensor_msgs');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------


//-----------------------------------------------------------

class TemplateMatchRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.initial_estimate = null;
      this.target_cloud = null;
    }
    else {
      if (initObj.hasOwnProperty('initial_estimate')) {
        this.initial_estimate = initObj.initial_estimate
      }
      else {
        this.initial_estimate = new geometry_msgs.msg.Transform();
      }
      if (initObj.hasOwnProperty('target_cloud')) {
        this.target_cloud = initObj.target_cloud
      }
      else {
        this.target_cloud = new sensor_msgs.msg.PointCloud2();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TemplateMatchRequest
    // Serialize message field [initial_estimate]
    bufferOffset = geometry_msgs.msg.Transform.serialize(obj.initial_estimate, buffer, bufferOffset);
    // Serialize message field [target_cloud]
    bufferOffset = sensor_msgs.msg.PointCloud2.serialize(obj.target_cloud, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TemplateMatchRequest
    let len;
    let data = new TemplateMatchRequest(null);
    // Deserialize message field [initial_estimate]
    data.initial_estimate = geometry_msgs.msg.Transform.deserialize(buffer, bufferOffset);
    // Deserialize message field [target_cloud]
    data.target_cloud = sensor_msgs.msg.PointCloud2.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += sensor_msgs.msg.PointCloud2.getMessageSize(object.target_cloud);
    return length + 56;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rail_mesh_icp/TemplateMatchRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '5a1a721a45213df31bc1d496889991c2';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    geometry_msgs/Transform initial_estimate
    sensor_msgs/PointCloud2 target_cloud
    
    ================================================================================
    MSG: geometry_msgs/Transform
    # This represents the transform between two coordinate frames in free space.
    
    Vector3 translation
    Quaternion rotation
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: sensor_msgs/PointCloud2
    # This message holds a collection of N-dimensional points, which may
    # contain additional information such as normals, intensity, etc. The
    # point data is stored as a binary blob, its layout described by the
    # contents of the "fields" array.
    
    # The point cloud data may be organized 2d (image-like) or 1d
    # (unordered). Point clouds organized as 2d images may be produced by
    # camera depth sensors such as stereo or time-of-flight.
    
    # Time of sensor data acquisition, and the coordinate frame ID (for 3d
    # points).
    Header header
    
    # 2D structure of the point cloud. If the cloud is unordered, height is
    # 1 and width is the length of the point cloud.
    uint32 height
    uint32 width
    
    # Describes the channels and their layout in the binary data blob.
    PointField[] fields
    
    bool    is_bigendian # Is this data bigendian?
    uint32  point_step   # Length of a point in bytes
    uint32  row_step     # Length of a row in bytes
    uint8[] data         # Actual point data, size is (row_step*height)
    
    bool is_dense        # True if there are no invalid points
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: sensor_msgs/PointField
    # This message holds the description of one point entry in the
    # PointCloud2 message format.
    uint8 INT8    = 1
    uint8 UINT8   = 2
    uint8 INT16   = 3
    uint8 UINT16  = 4
    uint8 INT32   = 5
    uint8 UINT32  = 6
    uint8 FLOAT32 = 7
    uint8 FLOAT64 = 8
    
    string name      # Name of field
    uint32 offset    # Offset from start of point struct
    uint8  datatype  # Datatype enumeration, see above
    uint32 count     # How many elements in the field
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TemplateMatchRequest(null);
    if (msg.initial_estimate !== undefined) {
      resolved.initial_estimate = geometry_msgs.msg.Transform.Resolve(msg.initial_estimate)
    }
    else {
      resolved.initial_estimate = new geometry_msgs.msg.Transform()
    }

    if (msg.target_cloud !== undefined) {
      resolved.target_cloud = sensor_msgs.msg.PointCloud2.Resolve(msg.target_cloud)
    }
    else {
      resolved.target_cloud = new sensor_msgs.msg.PointCloud2()
    }

    return resolved;
    }
};

class TemplateMatchResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.template_pose = null;
      this.match_error = null;
    }
    else {
      if (initObj.hasOwnProperty('template_pose')) {
        this.template_pose = initObj.template_pose
      }
      else {
        this.template_pose = new geometry_msgs.msg.TransformStamped();
      }
      if (initObj.hasOwnProperty('match_error')) {
        this.match_error = initObj.match_error
      }
      else {
        this.match_error = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TemplateMatchResponse
    // Serialize message field [template_pose]
    bufferOffset = geometry_msgs.msg.TransformStamped.serialize(obj.template_pose, buffer, bufferOffset);
    // Serialize message field [match_error]
    bufferOffset = _serializer.float64(obj.match_error, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TemplateMatchResponse
    let len;
    let data = new TemplateMatchResponse(null);
    // Deserialize message field [template_pose]
    data.template_pose = geometry_msgs.msg.TransformStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [match_error]
    data.match_error = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.TransformStamped.getMessageSize(object.template_pose);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rail_mesh_icp/TemplateMatchResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8df3a9cb24ef8a40a17eba4a923ca05c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    geometry_msgs/TransformStamped template_pose
    float64 match_error
    
    
    ================================================================================
    MSG: geometry_msgs/TransformStamped
    # This expresses a transform from coordinate frame header.frame_id
    # to the coordinate frame child_frame_id
    #
    # This message is mostly used by the 
    # <a href="http://wiki.ros.org/tf">tf</a> package. 
    # See its documentation for more information.
    
    Header header
    string child_frame_id # the frame id of the child frame
    Transform transform
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Transform
    # This represents the transform between two coordinate frames in free space.
    
    Vector3 translation
    Quaternion rotation
    
    ================================================================================
    MSG: geometry_msgs/Vector3
    # This represents a vector in free space. 
    # It is only meant to represent a direction. Therefore, it does not
    # make sense to apply a translation to it (e.g., when applying a 
    # generic rigid transformation to a Vector3, tf2 will only apply the
    # rotation). If you want your data to be translatable too, use the
    # geometry_msgs/Point message instead.
    
    float64 x
    float64 y
    float64 z
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TemplateMatchResponse(null);
    if (msg.template_pose !== undefined) {
      resolved.template_pose = geometry_msgs.msg.TransformStamped.Resolve(msg.template_pose)
    }
    else {
      resolved.template_pose = new geometry_msgs.msg.TransformStamped()
    }

    if (msg.match_error !== undefined) {
      resolved.match_error = msg.match_error;
    }
    else {
      resolved.match_error = 0.0
    }

    return resolved;
    }
};

module.exports = {
  Request: TemplateMatchRequest,
  Response: TemplateMatchResponse,
  md5sum() { return '322f29cf87c11235ad97d79b07db8f1a'; },
  datatype() { return 'rail_mesh_icp/TemplateMatch'; }
};
